{$N+}
program bezconstr;
uses Dos,Crt,GritN,cmstuf;
type punt = record x,y: real end;           {point}
     stuurpunten = array[0..30] of punt;    {guiding points}
     datarr = array[1..100] of real;
var p: stuurpunten;
    i,neval,number: integer;
    x,y: datarr;
    done: boolean;
    teksten: ButtTxtArr;

procedure StuurpDef(var s: stuurpunten; var number: integer);
var knop: integer;
    i: integer;
    u,v: real;
begin
     Prompt('click left max. 20 control points; click right AFTER last point');
     Locator(u,v,knop); Marker(u,v,fsquare,lightred);
     i:=0; s[i].x:=u; s[i].y:=v;
     repeat
         Locator(u,v,knop);
           if knop=1 then
             begin
                Marker(u,v,fsquare,lightred);
                i:=i+1;
                s[i].x:=u; s[i].y:=v
             end
     until (knop=2) or (i=20);
     number:=i; {real # guiding pnts is number+1 as count starts with 0}
end;

procedure Bezier(p: stuurpunten; mst: integer; var x,y: datarr);
const neval = 100;
var i,j,n: integer;
    r,q: stuurpunten;
    t,dt: real;
begin (* bezier *)
     dt:=1.0/(neval-1); t:=0.0;
     for j:=1 to neval do
         begin for i:=0 to mst do
                   begin r[i].x:=p[i].x;
                         r[i].y:=p[i].y
                   end;
                n:=mst;
                while n>0 do
                      begin for i:=0 to n-1 do
                                begin q[i].x:=r[i].x + t*(r[i+1].x - r[i].x);
                                      q[i].y:=r[i].y + t*(r[i+1].y - r[i].y)
                                end;
                            n:=n-1;
                            for i:=0 to n do
                                begin r[i].x:=q[i].x;
                                      r[i].y:=q[i].y
                                end;
                       end; (* while *)
                 x[j]:=r[0].x;
                 y[j]:=r[0].y;
                 t:=t+dt
           end;
end;

procedure edit(var done: boolean);
var q,ok: integer;

procedure grab(var u,v: real; var n: integer);
var mindist,d: real;
    i: integer;

function dist(x,y: real; n: integer; var d: real): real;
begin
     d:=sqr(x-p[n].x)+sqr(y-p[n].y);
     dist:=d
end;

begin
     mindist:=1000;
     for i:=number downto 0 do
         if dist(u,v,i,d) < mindist then begin n:=i; mindist:=d end;
     u:=p[n].x; v:=p[n].y
end;  {grab}

procedure append;
var i,m,n: integer;
    knop: integer;
    u,v: real;
begin
     Prompt('click predecessor of control point to be inserted');
     Locator(u,v,knop); grab(u,v,n);
     Prompt('click position of new control point');
     Locator(u,v,knop);
     m:=n+1;
     for i:=number downto m do p[i+1]:=p[i];
     p[m].x:=u; p[m].y:=v;
     number:=number+1;
end;

procedure move;
var n: integer;
    knop: integer;
    u,v: real;
begin
     Prompt('click control point to be shifted');
     Locator(u,v,knop); grab(u,v,n);
     Prompt('click new position');
     Locator(u,v,knop);
     p[n].x:=u; p[n].y:=v;
end;

procedure delete;
var i,n,knop: integer;
    u,v: real;
begin
     Prompt('click control point to be deleted');
     Locator(u,v,knop); grab(u,v,n);
     for i:=n to number do p[i]:=p[i+1];
     number:=number-1
end;


procedure show;
var i,ok: integer;
begin
     ClearViewport;
     Bezier(p,number,x,y);
     Polyline(@x,@y,100,yellow,nonclosed);
     Prompt('now choose <show contr points>');
     repeat ok:=ReadButton(q) until q=6;
     for i:=1 to number+1 do
         begin x[i]:=p[i-1].x; y[i]:=p[i-1].y end;
     Polyline(@x,@y,number+1,lightgreen,nonclosed);
     for i:=0 to number do Marker(p[i].x,p[i].y,fsquare,lightred)
end;

procedure display;
var i: integer;
begin
     ClearViewport;
     for i:=1 to number+1 do
         begin x[i]:=p[i-1].x; y[i]:=p[i-1].y end;
     Polyline(@x,@y,number+1,lightgreen,nonclosed);
     Bezier(p,number,x,y);
     Polyline(@x,@y,100,yellow,nonclosed);
     for i:=0 to number do Marker(p[i].x,p[i].y,fsquare,lightred)
end;

begin {edit}
repeat
      Prompt('make een choice from the menu');
      ok:=ReadButton(q);
      case q of
        1: begin append; display end;
        3: begin move; display end;
        2: begin delete; display end;
        5: show;
        8: begin done:=true; exit end;
      end
until false;
end; {edit}


begin (* bezconstr *)
    hello('Program 12',
        'Make curved lines using Bezier''s algorithm', 'uk');
     SetUpGraphics;
     SetViewport(0.1,0.1, 0.9,0.6, yellow);
     SetWindow(0,0, 0.8,0.5);
     teksten[1]:='insert';
     teksten[2]:='delete';
     teksten[3]:='shift';
     teksten[4]:='';
     teksten[5]:='show|curve';
     teksten[6]:='control|points';
     teksten[7]:='';
     teksten[8]:='stop';
     DefineButtons(teksten);
     StuurpDef(p,number);
     Bezier(p,number,x,y);
     Polyline(@x,@y,100,yellow,nonclosed);
     done:=false;
     repeat edit(done) until done;
     DoneGraphics;
end.
